import { Route } from 'alinea/backend/router/Router';
import { Auth } from 'alinea/core/Auth';
import { Connection } from 'alinea/core/Connection';
import { User } from 'alinea/core/User';
import type { Transporter } from 'nodemailer';
export type PasswordLessAuthOptions = {
    dashboardUrl: string;
    subject: string;
    from: string;
    transporter: Transporter;
    jwtSecret: string;
    isUser: (email: string) => Promise<boolean>;
};
export declare class PasswordLessAuth implements Auth.Server {
    protected options: PasswordLessAuthOptions;
    router: Route<Request, Response | undefined>;
    users: WeakMap<Request, User>;
    constructor(options: PasswordLessAuthOptions);
    contextFor(request: Request): Promise<Connection.AuthContext>;
    userFor(request: Request): Promise<User>;
}
