export declare function createExample(): {
    schema: {
        Fields: import("alinea/core/Type").Type<{
            title: import("../../field/text").TextField;
            path: import("../../field/path").PathField;
            metadata: import("../../field/metadata").MetadataField;
        } & {
            text: import("../../field/text").TextField;
            hello: import("../../field/text").TextField;
            richText: import("../../core").RichTextField<{}, import("../../field/richtext").RichTextOptions<{}>>;
            select: import("../../field/select").SelectField<"a" | "b">;
            number: import("../../field/number").NumberField;
            check: import("../../field/check").CheckField;
            date: import("../../field/date").DateField;
            code: import("../../field/code").CodeField;
            externalLink: import("../../field/link/LinkField").LinkField<import("../..").UrlReference, import("../..").UrlLink<{}>>;
            entry: import("../../field/link/LinkField").LinkField<import("../..").EntryReference, import("../..").EntryLink<undefined>>;
            entryWithCondition: import("../../field/link/LinkField").LinkField<import("../..").EntryReference, import("../..").EntryLink<undefined>>;
            linkMultiple: import("../../field/link/LinkField").LinksField<import("../../core/shape/ListShape").ListRow, import("../..").AnyLink<{}>>;
            image: import("../../field/link").ImageField<undefined>;
            images: import("../../field/link").ImagesField<undefined>;
            file: import("../../field/link/LinkField").LinkField<import("../..").EntryReference, import("../..").EntryLink<undefined>>;
            withFields: import("../../field/link/LinkField").LinkField<import("../../core/Reference").Reference, import("../..").AnyLink<{
                fieldA: string;
                fieldB: string;
            }>>;
            multipleWithFields: import("../../field/link/LinkField").LinksField<import("../../core/shape/ListShape").ListRow, import("../..").AnyLink<{
                fieldA: string;
                fieldB: string;
            }>>;
            list: import("../../core").ListField<({
                _type: "Text";
                title: string;
                text: import("../..").TextDoc<{}>;
            } | {
                _type: "Image";
                image: import("../..").EntryReference;
            }) & import("../../core/shape/ListShape").ListRow, ({
                _type: "Text";
                title: string;
                text: import("../..").TextDoc<{}>;
            } | {
                _type: "Image";
                image: import("../..").ImageLink<undefined>;
            }) & import("../../core/shape/ListShape").ListRow, import("../../field/list").ListOptions<{
                Text: import("alinea/core/Type").Type<{
                    title: import("../../field/text").TextField;
                    text: import("../../core").RichTextField<{}, import("../../field/richtext").RichTextOptions<{}>>;
                }>;
                Image: import("alinea/core/Type").Type<{
                    image: import("../../field/link").ImageField<undefined>;
                }>;
            }>>;
            withInitial: import("../../core").RichTextField<{}, import("../../field/richtext").RichTextOptions<{}>>;
            nested: import("../../core").RichTextField<{
                Inner: import("alinea/core/Type").Type<{
                    checkbox1: import("../../field/check").CheckField;
                    checkbox2: import("../../field/check").CheckField;
                    title: import("../../field/text").TextField;
                    content: import("../../core").RichTextField<{}, import("../../field/richtext").RichTextOptions<{}>>;
                }>;
                NestLayout: import("alinea/core/Type").Type<{
                    tabA: import("../../field/text").TextField;
                    tabB: import("../../field/text").TextField;
                    object: import("../../field/object").ObjectField<{
                        fieldA: import("../../field/text").TextField;
                        fieldB: import("../../field/text").TextField;
                    }>;
                }>;
            }, import("../../field/richtext").RichTextOptions<{
                Inner: import("alinea/core/Type").Type<{
                    checkbox1: import("../../field/check").CheckField;
                    checkbox2: import("../../field/check").CheckField;
                    title: import("../../field/text").TextField;
                    content: import("../../core").RichTextField<{}, import("../../field/richtext").RichTextOptions<{}>>;
                }>;
                NestLayout: import("alinea/core/Type").Type<{
                    tabA: import("../../field/text").TextField;
                    tabB: import("../../field/text").TextField;
                    object: import("../../field/object").ObjectField<{
                        fieldA: import("../../field/text").TextField;
                        fieldB: import("../../field/text").TextField;
                    }>;
                }>;
            }>>;
        }>;
        Page: import("alinea/core/Type").Type<{
            name: import("../../field/path").PathField & import("../../field/text").TextField;
            name2: import("../../field/text").TextField;
            title: import("../../field/text").TextField;
            path: import("../../field/path").PathField;
        }>;
        Container: import("alinea/core/Type").Type<{
            title: import("../../field/text").TextField;
            path: import("../../field/path").PathField;
            name: import("../../field/text").TextField;
        }>;
    };
    workspaces: {
        main: import("alinea/core/Workspace").Workspace<{
            pages: import("alinea/core/Root").Root<{
                entry1: import("alinea/core/Page").PageSeed<{
                    name: import("../../field/path").PathField & import("../../field/text").TextField;
                    name2: import("../../field/text").TextField;
                    title: import("../../field/text").TextField;
                    path: import("../../field/path").PathField;
                }, Record<string, any>>;
                entry2: import("alinea/core/Page").PageSeed<{
                    title: import("../../field/text").TextField;
                    path: import("../../field/path").PathField;
                    name: import("../../field/text").TextField;
                }, Record<string, any>>;
            }>;
            multiLanguage: import("alinea/core/Root").Root<{
                localised1: import("alinea/core/Page").PageSeed<{
                    name: import("../../field/path").PathField & import("../../field/text").TextField;
                    name2: import("../../field/text").TextField;
                    title: import("../../field/text").TextField;
                    path: import("../../field/path").PathField;
                }, Record<string, any>>;
                localised2: import("alinea/core/Page").PageSeed<{
                    title: import("../../field/text").TextField;
                    path: import("../../field/path").PathField;
                    name: import("../../field/text").TextField;
                }, Record<string, any>>;
            }>;
            media: import("alinea/core/media/MediaRoot").MediaRoot<{
                dir: import("alinea/core/Page").PageSeed<{
                    title: import("../../field/hidden").HiddenField<string>;
                    path: import("../../field/hidden").HiddenField<string>;
                }, Record<string, any>>;
                'file1.png': import("alinea/core/Page").PageSeed<{
                    title: import("../../field/hidden").HiddenField<string>;
                    path: import("../../field/hidden").HiddenField<string>;
                    location: import("../../field/hidden").HiddenField<string>;
                    extension: import("../../field/hidden").HiddenField<string>;
                    size: import("../../field/hidden").HiddenField<number>;
                    hash: import("../../field/hidden").HiddenField<string>;
                    width: import("../../field/hidden").HiddenField<number>;
                    height: import("../../field/hidden").HiddenField<number>;
                    preview: import("../../field/hidden").HiddenField<string>;
                    averageColor: import("../../field/hidden").HiddenField<string>;
                    focus: import("../../field/hidden").HiddenField<{
                        x: number;
                        y: number;
                    }>;
                    thumbHash: import("../../field/hidden").HiddenField<string>;
                }, Record<string, any>>;
            }>;
        }>;
    };
} & import("alinea/core/driver/TestDriver").TestApi & import("../../core/CMS").CMS;
