import {
  Batch,
  Expr,
  Functions,
  Query,
  RecursiveUnion,
  Schema,
  Table,
  createTable
} from "./chunk-4JLFL6LD.js";

// node_modules/rado/dist/define/Ops.js
var value = Expr.value;
var and = Expr.and;
var or = Expr.or;
function withRecursive(initialSelect) {
  return new RecursiveUnion(initialSelect[Query.Data]);
}
function alias(table) {
  return new Proxy(/* @__PURE__ */ Object.create(null), {
    get(_, alias2) {
      return createTable({ ...table[Table.Data], alias: alias2 });
    }
  });
}
function create(...tables) {
  return new Batch(
    tables.flatMap((table) => Schema.create(table[Table.Data]).queries)
  );
}

// node_modules/rado/dist/sqlite/SqliteFunctions.js
var SqliteFunctions = Functions;
var {
  count,
  iif,
  exists,
  match,
  bm25,
  highlight,
  snippet,
  cast,
  abs,
  changes,
  char,
  coalesce,
  ifnull,
  instr,
  last_insert_rowid,
  length,
  likelihood,
  likely,
  lower,
  ltrim,
  max,
  min,
  nullif,
  prnumberf,
  quote,
  random,
  replace,
  round,
  rtrim,
  sign,
  soundex,
  sqlite_version,
  substr,
  total_changes,
  trim,
  unicode,
  unlikely,
  upper,
  avg,
  group_concat,
  sum,
  acos,
  acosh,
  asin,
  asinh,
  atan,
  atan2,
  atanh,
  ceil,
  cos,
  cosh,
  degrees,
  exp,
  floor,
  ln,
  log,
  log2,
  mod,
  pi,
  pow,
  radians,
  sin,
  sinh,
  sqrt,
  tan,
  tanh,
  trunc,
  date,
  time,
  datetime,
  julianday,
  strftime
} = SqliteFunctions;

export {
  withRecursive,
  alias,
  create,
  count,
  iif,
  exists,
  match,
  bm25,
  snippet
};
