// node_modules/lib0/math.js
var floor = Math.floor;
var abs = Math.abs;
var min = (a, b) => a < b ? a : b;
var max = (a, b) => a > b ? a : b;
var isNaN = Number.isNaN;
var isNegativeZero = (n) => n !== 0 ? n < 0 : 1 / n < 0;

// node_modules/lib0/error.js
var create = (s) => new Error(s);
var methodUnimplemented = () => {
  throw create("Method unimplemented");
};
var unexpectedCase = () => {
  throw create("Unexpected case");
};

// node_modules/lib0/time.js
var getUnixTime = Date.now;

// node_modules/lib0/promise.js
var create2 = (f) => (
  /** @type {Promise<T>} */
  new Promise(f)
);
var all = Promise.all.bind(Promise);

export {
  floor,
  abs,
  min,
  max,
  isNegativeZero,
  create,
  methodUnimplemented,
  unexpectedCase,
  getUnixTime,
  create2
};
