import "../../chunks/chunk-U5RRZUYZ.js";

// src/cli/generate/LoadConfig.ts
import { CMS } from "alinea/core/CMS";
import { createCMS } from "alinea/core/driver/DefaultDriver";
import { createRequire } from "node:module";
import path from "node:path";
async function loadCMS(outDir) {
  const unique = Date.now();
  const genConfigFile = path.join(outDir, "config.js").replace(/\\/g, "/");
  const outFile = `file://${genConfigFile}?${unique}`;
  global.require = createRequire(import.meta.url);
  const exports = await import(outFile);
  if ("cms" in exports && exports.cms instanceof CMS)
    return exports.cms;
  if ("config" in exports)
    return createCMS(exports.config);
  throw new Error(`No config found in "${genConfigFile}"`);
}
export {
  loadCMS
};
