import { Request, Response } from '@alinea/iso';
import { Route } from 'alinea/backend/router/Router';
import { Auth } from 'alinea/core/Auth';
import { Config } from 'alinea/core/Config';
import { User } from 'alinea/core/User';
import { AuthResult } from '../AuthResult.js';
export type CloudAuthServerOptions = {
    config: Config;
    apiKey: string | undefined;
};
export declare class CloudAuthServer implements Auth.Server {
    private options;
    router: Route<Request, Response | undefined>;
    context: WeakMap<globalThis.Request, {
        token: string;
        user: User;
    }>;
    dashboardUrl: string;
    constructor(options: CloudAuthServerOptions);
    authResult(request: Request): Promise<AuthResult>;
    contextFor(request: Request): Promise<{
        token: string;
        user: User;
    }>;
}
