import { Config } from './Config.js';
import { Connection } from './Connection.js';
import { Graph, GraphRealm } from './Graph.js';
import { Resolver } from './Resolver.js';
import { Root } from './Root.js';
import { Operation } from './Transaction.js';
import { Workspace } from './Workspace.js';
type Attachment = Workspace | Root;
export declare abstract class CMS extends GraphRealm {
    #private;
    graph: Graph;
    config: Config;
    constructor(config: Config);
    abstract resolver(): Promise<Resolver>;
    abstract connection(): Promise<Connection>;
    commit(...operations: Array<Operation>): Promise<{
        commitHash: string;
    }>;
    get schema(): import("./Schema.js").Schema<{}>;
    get workspaces(): Record<string, Workspace>;
}
export declare namespace CMS {
    function instanceFor(attachment: Attachment): CMS;
}
export {};
