import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Document.ts
import { metadata } from "alinea/field/metadata";
import { path } from "alinea/field/path";
import { tab, tabs } from "alinea/field/tabs";
import { text } from "alinea/field/text";
import { IcRoundDescription } from "alinea/ui/icons/IcRoundDescription";
import { IcRoundShare } from "alinea/ui/icons/IcRoundShare";
import {
  parseTypeParams,
  type
} from "./Type.js";
function document(label, definition) {
  const { definition: d, options } = parseTypeParams(definition);
  return type(label, {
    ...options,
    fields: {
      ...tabs(
        tab("Document", {
          icon: IcRoundDescription,
          fields: {
            title: text("Title", { required: true, width: 0.5 }),
            path: path("Path", { required: true, width: 0.5 }),
            ...d
          }
        }),
        tab("Metadata", {
          icon: IcRoundShare,
          fields: {
            metadata: metadata()
          }
        })
      )
      // Todo: Fix type
    }
  });
}
export {
  document
};
