import { File } from '@alinea/iso';
import { ListEditor, ListField } from 'alinea/core/field/ListField';
import { RichTextEditor, RichTextField } from 'alinea/core/field/RichTextField';
import type { ListRow } from 'alinea/core/shape/ListShape';
import type { Entry } from './Entry.js';
import { TextDoc } from './TextDoc.js';
import { CreateOperation, DeleteOp, EditOperation, UploadOperation, UploadOptions } from './Transaction.js';
import { Type } from './Type.js';
export declare function Edit<Definition>(entryId: string, type?: Type<Definition>): EditOperation<Definition>;
export declare namespace Edit {
    function create<Definition>(type: Type<Definition>): CreateOperation<Definition>;
    function createEntry(entry: Entry): CreateOperation<unknown>;
    function remove(entryId: string): DeleteOp;
    function upload(file: File | [string, Uint8Array], options?: UploadOptions): UploadOperation;
    function archive(entryId: string): EditOperation<unknown>;
    function publish(entryId: string): EditOperation<unknown>;
    function list<StoredValue extends ListRow, QueryValue extends ListRow>(field: ListField<StoredValue, QueryValue, any>, current?: Array<StoredValue>): ListEditor<StoredValue>;
    function richText<Blocks>(field: RichTextField<Blocks, any>, current?: TextDoc<Blocks>): RichTextEditor<Blocks>;
}
