import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Edit.ts
import { ListEditor } from "alinea/core/field/ListField";
import { RichTextEditor } from "alinea/core/field/RichTextField";
import {
  CreateOperation,
  DeleteOp,
  EditOperation,
  UploadOperation
} from "./Transaction.js";
function Edit(entryId, type) {
  return new EditOperation(entryId);
}
((Edit2) => {
  function create(type) {
    return new CreateOperation({}, type);
  }
  Edit2.create = create;
  function createEntry(entry) {
    return new CreateOperation(entry);
  }
  Edit2.createEntry = createEntry;
  function remove(entryId) {
    return new DeleteOp(entryId);
  }
  Edit2.remove = remove;
  function upload(file, options) {
    return new UploadOperation(file, options);
  }
  Edit2.upload = upload;
  function archive(entryId) {
    return Edit2(entryId).archive();
  }
  Edit2.archive = archive;
  function publish(entryId) {
    return Edit2(entryId).publish();
  }
  Edit2.publish = publish;
  function list(field, current) {
    return new ListEditor(current);
  }
  Edit2.list = list;
  function richText(field, current) {
    return new RichTextEditor(current);
  }
  Edit2.richText = richText;
})(Edit || (Edit = {}));
export {
  Edit
};
