import { table } from 'rado';
export declare enum EntryPhase {
    Draft = "draft",
    Published = "published",
    Archived = "archived"
}
export declare const ALT_STATUS: Array<EntryPhase>;
export type EntryLinks = {
    [field: string]: Array<string>;
};
export declare class EntryTable {
    entryId: import("rado").OptionalColumn<string>;
    phase: import("rado").ValueColumn<EntryPhase>;
    title: import("rado").ValueColumn<string>;
    type: import("rado").ValueColumn<string>;
    seeded: import("rado").NullableValueColumn<string>;
    workspace: import("rado").ValueColumn<string>;
    root: import("rado").ValueColumn<string>;
    index: import("rado").ValueColumn<string>;
    parent: import("rado").NullableValueColumn<string>;
    i18nId: import("rado").ValueColumn<string>;
    locale: import("rado").NullableValueColumn<string>;
    active: import("rado").ValueColumn<boolean>;
    main: import("rado").ValueColumn<boolean>;
    get versionId(): import("rado").Expr<string>;
    path: import("rado").ValueColumn<string>;
    data: import("rado").ValueColumn<any>;
    level: import("rado").ValueColumn<number>;
    filePath: import("rado").ValueColumn<string>;
    parentDir: import("rado").ValueColumn<string>;
    childrenDir: import("rado").ValueColumn<string>;
    /** @deprecated */
    modifiedAt: import("rado").ValueColumn<number>;
    rowHash: import("rado").ValueColumn<string>;
    fileHash: import("rado").ValueColumn<string>;
    url: import("rado").ValueColumn<string>;
    searchableText: import("rado").ValueColumn<string>;
}
/**
 * Represents an Entry row in the database,
 * field data is available in the data column in JSON format.
 */
export type EntryRow<Data = Record<string, any>> = table<EntryTable> & {
    data: Data;
};
export declare const EntryRow: import("rado").IndexedTable<EntryTable, "rowHash" | "type" | "parent" | "url" | "path" | "fileIdentifier" | "parentDir" | "childrenDir" | "versionId" | "phase" | "i18nId">;
