import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Root.ts
import { Meta } from "./Meta.js";
var Root;
((Root2) => {
  Root2.Data = Symbol.for("@alinea/Root.Data");
  function label(root2) {
    return root2[Root2.Data].label;
  }
  Root2.label = label;
  function data(root2) {
    return root2[Root2.Data];
  }
  Root2.data = data;
  function preview(root2) {
    return root2[Root2.Data].preview;
  }
  Root2.preview = preview;
  function defaultLocale(root2) {
    return root2[Root2.Data].i18n?.locales[0];
  }
  Root2.defaultLocale = defaultLocale;
  function isRoot(value) {
    return Boolean(value && value[Root2.Data]);
  }
  Root2.isRoot = isRoot;
  function isMediaRoot(root2) {
    return Boolean(root2[Root2.Data].isMediaRoot);
  }
  Root2.isMediaRoot = isMediaRoot;
  function validate(root2, workspaceLabel, schema) {
    const { contains } = root2[Root2.Data];
    for (const key of contains ?? []) {
      if (!schema[key])
        throw new Error(
          `Root "${label(
            root2
          )}" in workspace "${workspaceLabel}" contains "${key}", but that Type does not exist`
        );
    }
  }
  Root2.validate = validate;
})(Root || (Root = {}));
function root(label, definition = {}) {
  const def = definition;
  const isOptions = "entries" in def || !def[Meta];
  const entries = isOptions ? def.entries : definition;
  const options = isOptions ? def : def[Meta];
  return {
    ...entries,
    [Root.Data]: {
      label,
      ...options
    }
  };
}
((root2) => {
  root2.meta = Meta;
})(root || (root = {}));
export {
  Root,
  root
};
