import { Hint } from './Hint.js';
import { Type, TypeTarget } from './Type.js';
import { RecordShape } from './shape/RecordShape.js';
export interface Schema<Definitions = {}> extends Record<string, Type> {
}
export declare namespace Schema {
    type Targets = Map<TypeTarget, string>;
    function validate(schema: Schema): void;
    function shapes(schema: Schema): Record<string, RecordShape>;
    function hint(schema: Schema): Hint.Union;
    function targets(schema: Schema): Targets;
    function typeNames(schema: Schema): Map<Type, string>;
}
export interface SchemaTypes {
    [key: string]: Type;
}
export interface SchemaOptions<Definition> {
    types: Definition;
}
export declare function schema<Definition extends SchemaTypes>(options: SchemaOptions<Definition>): Definition;
/** @deprecated See https://github.com/alineacms/alinea/issues/373 */
export declare function schema<Definition extends SchemaTypes>(options: Definition): Definition;
