import { Field, FieldMeta, FieldOptions } from '../Field.js';
import { TextDoc } from '../TextDoc.js';
import { RecordShape } from '../shape/RecordShape.js';
import { RichTextMutator } from '../shape/RichTextShape.js';
export declare class RichTextField<Blocks, Options extends FieldOptions<TextDoc<Blocks>> & {
    searchable?: boolean;
}> extends Field<TextDoc<Blocks>, TextDoc<Blocks>, RichTextMutator<Blocks>, Options> {
    constructor(shape: {
        [key: string]: RecordShape<any>;
    } | undefined, meta: FieldMeta<TextDoc<Blocks>, TextDoc<Blocks>, RichTextMutator<Blocks>, Options>);
}
export declare class RichTextEditor<Blocks> {
    private doc;
    constructor(doc?: TextDoc<Blocks>);
    addHtml(html: string): this;
    value(): TextDoc<Blocks>;
}
export declare function parseHTML(html: string): TextDoc<any>;
