import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaTypes.browser.tsx
import { MediaExplorer } from "alinea/dashboard/view/MediaExplorer";
import { FileEntry } from "alinea/dashboard/view/media/FileEntry";
import {
  FileSummaryRow,
  FileSummaryThumb
} from "alinea/dashboard/view/media/FileSummary";
import { text } from "alinea/field/text/TextField";
import { IcRoundPermMedia } from "alinea/ui/icons/IcRoundPermMedia";
import { Entry } from "../Entry.js";
import { Query } from "../Query.js";
import { type } from "../Type.js";
import { view } from "../View.js";
import * as config from "./MediaTypes.js";
function fileSummarySelect() {
  return {
    entryId: Entry.entryId,
    i18nId: Entry.i18nId,
    type: Entry.type,
    workspace: Entry.workspace,
    root: Entry.root,
    title: Entry.title,
    extension: MediaFile2.extension,
    size: MediaFile2.size,
    preview: MediaFile2.preview,
    thumbHash: MediaFile2.thumbHash,
    averageColor: MediaFile2.averageColor,
    focus: MediaFile2.focus,
    width: MediaFile2.width,
    height: MediaFile2.height,
    parents: Query.parents().select({
      entryId: Entry.entryId,
      i18nId: Entry.i18nId,
      title: Entry.title
    })
  };
}
var MediaLibrary2 = type(
  "Media directory",
  {
    contains: ["MediaLibrary"],
    view: MediaExplorer,
    icon: IcRoundPermMedia,
    fields: {
      ...config.MediaLibrary
    }
  }
);
var MediaFile2 = type("File", {
  hidden: true,
  summaryRow: view(fileSummarySelect, FileSummaryRow),
  summaryThumb: view(fileSummarySelect, FileSummaryThumb),
  view: FileEntry,
  fields: {
    ...config.MediaFile,
    title: text("Title")
  }
});
export {
  MediaFile2 as MediaFile,
  MediaLibrary2 as MediaLibrary,
  fileSummarySelect
};
