import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaTypes.ts
import { hidden } from "alinea/field/hidden";
import { Hint } from "../Hint.js";
import { type } from "../Type.js";
var MediaLibrary = type("Media directory", {
  isContainer: true,
  contains: ["MediaLibrary"],
  fields: {
    title: hidden("Title", Hint.String()),
    path: hidden("Path", Hint.String())
  }
});
var MediaFile = type("Media file", {
  hidden: true,
  fields: {
    title: hidden("Title", Hint.String()),
    path: hidden("Path", Hint.String()),
    location: hidden("Location", Hint.String()),
    extension: hidden("Extension", Hint.String()),
    size: hidden("File size", Hint.Number()),
    hash: hidden("Hash", Hint.String()),
    width: hidden("Image width", Hint.Number()),
    height: hidden("Image height", Hint.Number()),
    preview: hidden("Preview", Hint.String()),
    averageColor: hidden("Average color", Hint.String()),
    focus: hidden(
      "Focus",
      Hint.Object({
        x: Hint.Number(),
        y: Hint.Number()
      })
    ),
    thumbHash: hidden("Blur hash", Hint.String())
  }
});
export {
  MediaFile,
  MediaLibrary
};
