/// <reference types="react" />
import { Root } from 'alinea/core/Root';
import { EntryLocation } from '../DashboardNav.js';
export declare const workspaceAtom: import("jotai").Atom<{
    label: string;
    roots: {
        [x: string]: Root;
    };
    color: string;
    source: string;
    mediaDir?: string | undefined;
    icon?: import("react").ComponentType | undefined;
    preview?: import("../../core/Preview.js").Preview | undefined;
    name: string;
}>;
export declare const rootAtom: import("jotai").Atom<{
    label: string;
    contains?: string[] | undefined;
    icon?: import("react").ComponentType | undefined;
    i18n?: import("alinea/core/Root").RootI18n | undefined;
    view?: import("react").ComponentType<{
        root: import("alinea/core/Root").RootData;
    }> | undefined;
    isMediaRoot?: boolean | undefined;
    preview?: import("../../core/Preview.js").Preview | undefined;
    name: string;
}>;
export declare const preferredLanguageAtom: import("jotai").WritableAtom<string | undefined, [string | typeof import("jotai/utils").RESET | ((prev: string | undefined) => string | typeof import("jotai/utils").RESET | undefined) | undefined], void>;
export declare const localeAtom: import("jotai").Atom<string | undefined>;
export declare const entryLocationAtom: import("jotai").Atom<EntryLocation>;
export declare const navAtom: import("jotai").Atom<{
    matchEntry: "/entry/*";
    matchEntryId: "/:action/:workspace/:root?/:entryId?";
    matchWorkspace: "/:action/:workspace";
    matchRoot: "/:action/:workspace/:root";
    root: ({ entryId, i18nId, ...location }: EntryLocation) => string;
    entry: (location: EntryLocation) => string;
    draft: (location: EntryLocation) => string;
    create: (location: EntryLocation) => string;
}>;
export declare const usePreferredLanguage: () => [string | undefined, (args_0: string | typeof import("jotai/utils").RESET | ((prev: string | undefined) => string | typeof import("jotai/utils").RESET | undefined) | undefined) => void];
