import "../../chunks/chunk-U5RRZUYZ.js";

// src/field/date/DateField.browser.tsx
import { Field } from "alinea/core";
import { useField } from "alinea/dashboard/editor/UseField";
import { InputLabel } from "alinea/dashboard/view/InputLabel";
import { fromModule } from "alinea/ui";
import { IcRoundDateRange } from "alinea/ui/icons/IcRoundDateRange";
import { date as createDate } from "./DateField.js";

// src/field/date/DateField.module.scss
var DateField_module_default = {
  "root-input": "alinea-DateField-input",
  "rootInput": "alinea-DateField-input"
};

// src/field/date/DateField.browser.tsx
export * from "./DateField.js";
import { jsx } from "react/jsx-runtime";
var date = Field.provideView(DateInput, createDate);
var styles = fromModule(DateField_module_default);
function DateInput({ field }) {
  const { options, value, mutator, error } = useField(field);
  return /* @__PURE__ */ jsx(InputLabel, { asLabel: true, ...options, error, icon: IcRoundDateRange, children: /* @__PURE__ */ jsx(
    "input",
    {
      className: styles.root.input(),
      type: "date",
      value: value ?? "",
      onChange: (e) => mutator(e.currentTarget.value),
      autoFocus: options.autoFocus,
      readOnly: options.readOnly
    }
  ) });
}
export {
  date
};
