import "../../chunks/chunk-U5RRZUYZ.js";

// src/field/metadata/MetadataField.tsx
import { Type, type } from "alinea/core/Type";
import { RecordField } from "alinea/core/field/RecordField";
import { image } from "alinea/field/link";
import { object } from "alinea/field/object";
import { text } from "alinea/field/text";
var MetadataField = class extends RecordField {
};
function metadata(label = "Metadata", options = {}) {
  const fields = type("Fields", {
    fields: {
      title: text("Title", { width: 0.5 }),
      description: text("Description", { multiline: true }),
      openGraph: object("Open graph", {
        fields: {
          title: text("Title", { width: 0.5 }),
          image: image("Image", { width: 0.5 }),
          description: text("Description", { multiline: true })
        }
      })
    }
  });
  return new MetadataField(Type.shape(fields), {
    hint: Type.hint(fields),
    options: { label, ...options, fields }
  });
}
export {
  MetadataField,
  metadata
};
