import "../../chunks/chunk-U5RRZUYZ.js";

// src/picker/entry/EntryPickerRow.tsx
import { Type } from "alinea/core/Type";
import { useConfig } from "alinea/dashboard/hook/UseConfig";
import { useEntrySummary } from "alinea/dashboard/hook/UseEntrySummary";
import { EntrySummaryRow } from "alinea/dashboard/view/entry/EntrySummary";
import { EntryReference } from "./EntryReference.js";
import { jsx } from "react/jsx-runtime";
function EntryPickerRow({ reference }) {
  const entry = useEntrySummary(reference[EntryReference.entry]);
  const { schema } = useConfig();
  if (!entry)
    return null;
  const type = schema[entry.type];
  const View = type && Type.meta(type).summaryRow || EntrySummaryRow;
  return /* @__PURE__ */ jsx(View, { ...entry });
}
export {
  EntryPickerRow
};
